Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GlopSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GlopSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GlopSolver.cs	(revision 16582)
@@ -21,4 +21,5 @@
 
 using System;
+using Google.OrTools.LinearSolver;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -26,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [Item("Glop", "Glop (https://developers.google.com/optimization/lp/glop) can be used out of the box.")]
@@ -37,6 +38,7 @@
         "# for file format, see Protocol Buffers text format (https://developers.google.com/protocol-buffers/docs/overview#whynotxml)" + Environment.NewLine +
         "# for parameters, see https://github.com/google/or-tools/blob/v6.10/ortools/glop/parameters.proto" + Environment.NewLine +
-        "# example:" + Environment.NewLine +
-        "# random_seed: 10" + Environment.NewLine;
+        "# examples:" + Environment.NewLine +
+        "# random_seed: 10" + Environment.NewLine +
+        "# use_dual_simplex: true (LP)" + Environment.NewLine;
     }
 
@@ -50,6 +52,8 @@
     }
 
-    protected override OptimizationProblemType OptimizationProblemType =>
-      OptimizationProblemType.GlopLinearProgramming;
+    protected override Solver.OptimizationProblemType OptimizationProblemType =>
+      Solver.OptimizationProblemType.GlopLinearProgramming;
+
+    public override IDeepCloneable Clone(Cloner cloner) => new GlopSolver(this, cloner);
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GlpkSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GlpkSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GlpkSolver.cs	(revision 16582)
@@ -20,4 +20,5 @@
 #endregion
 
+using Google.OrTools.LinearSolver;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -26,5 +27,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [Item("GLPK", "GLPK (https://www.gnu.org/software/glpk/) can be used out of the box.")]
@@ -49,8 +50,10 @@
     public override bool SupportsPause => false;
 
-    protected override OptimizationProblemType OptimizationProblemType =>
+    protected override Solver.OptimizationProblemType OptimizationProblemType =>
       ProblemType == ProblemType.LinearProgramming
-        ? OptimizationProblemType.GlpkLinearProgramming
-        : OptimizationProblemType.GlpkMixedIntegerProgramming;
+        ? Solver.OptimizationProblemType.GlpkLinearProgramming
+        : Solver.OptimizationProblemType.GlpkMixedIntegerProgramming;
+
+    public override IDeepCloneable Clone(Cloner cloner) => new GlpkSolver(this, cloner);
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GurobiSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GurobiSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/GurobiSolver.cs	(revision 16582)
@@ -21,4 +21,5 @@
 
 using System;
+using Google.OrTools.LinearSolver;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -27,5 +28,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [Item("Gurobi", "Gurobi (http://www.gurobi.com/) must be installed and licenced.")]
@@ -39,6 +40,8 @@
         "# for file format, see http://www.gurobi.com/documentation/8.1/refman/prm_format.html" + Environment.NewLine +
         "# for parameters, see http://www.gurobi.com/documentation/8.1/refman/parameters.html" + Environment.NewLine +
-        "# example:" + Environment.NewLine +
-        "# Seed 10" + Environment.NewLine;
+        "# examples:" + Environment.NewLine +
+        "# Seed 10" + Environment.NewLine +
+        "# Method 2 # Barrier (LP, root node of MIP)" + Environment.NewLine +
+        "# NodeMethod 2 # Barrier (MIP)" + Environment.NewLine;
     }
 
@@ -53,8 +56,10 @@
     }
 
-    protected override OptimizationProblemType OptimizationProblemType =>
+    protected override Solver.OptimizationProblemType OptimizationProblemType =>
       ProblemType == ProblemType.LinearProgramming
-        ? OptimizationProblemType.GurobiLinearProgramming
-        : OptimizationProblemType.GurobiMixedIntegerProgramming;
+        ? Solver.OptimizationProblemType.GurobiLinearProgramming
+        : Solver.OptimizationProblemType.GurobiMixedIntegerProgramming;
+
+    public override IDeepCloneable Clone(Cloner cloner) => new GurobiSolver(this, cloner);
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/ScipSolver.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/ScipSolver.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Algorithms/Solvers/ScipSolver.cs	(revision 16582)
@@ -22,4 +22,5 @@
 using System;
 using System.Threading;
+using Google.OrTools.LinearSolver;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,5 +30,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
 
   [Item("SCIP", "SCIP (http://scip.zib.de/) must be installed and licenced.")]
@@ -43,6 +44,8 @@
       SolverSpecificParameters =
         "# for file format and parameters, see https://scip.zib.de/doc/html/PARAMETERS.php" + Environment.NewLine +
-        "# example:" + Environment.NewLine +
-        "# branching/random/seed = 10" + Environment.NewLine;
+        "# examples:" + Environment.NewLine +
+        "# branching/random/seed = 10" + Environment.NewLine +
+        "# lp/initalgorithm = b # Barrier (root node of MIP)" + Environment.NewLine +
+        "# lp/resolvealgorithm = b # Barrier (MIP)" + Environment.NewLine;
     }
 
@@ -56,12 +59,14 @@
     }
 
+    protected override Solver.OptimizationProblemType OptimizationProblemType =>
+      Solver.OptimizationProblemType.ScipMixedIntegerProgramming;
+
     protected override TimeSpan IntermediateTimeLimit => timeLimit += QualityUpdateInterval;
 
-    protected override OptimizationProblemType OptimizationProblemType =>
-          OptimizationProblemType.ScipMixedIntegerProgramming;
+    public override IDeepCloneable Clone(Cloner cloner) => new ScipSolver(this, cloner);
 
-    public override void Solve(ILinearProgrammingProblemDefinition problemDefintion, ref TimeSpan executionTime, ResultCollection results, CancellationToken cancellationToken) {
+    public override void Solve(ILinearProblemDefinition problemDefintion, ResultCollection results, CancellationToken cancellationToken) {
       timeLimit = TimeSpan.Zero;
-      base.Solve(problemDefintion, ref executionTime, results, cancellationToken);
+      base.Solve(problemDefintion, results, cancellationToken);
     }
   }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/CompiledProblemDefinition.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/CompiledProblemDefinition.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/CompiledProblemDefinition.cs	(revision 16582)
@@ -20,10 +20,24 @@
 #endregion
 
-namespace HeuristicLab.MathematicalOptimization.LinearProgramming {
+using HeuristicLab.Common;
+using HeuristicLab.Core;
 
-  public abstract class CompiledProblemDefinition {
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
+
+  public class CompiledProblemDefinition : Item {
+
+    public CompiledProblemDefinition() {
+    }
+
+    protected CompiledProblemDefinition(CompiledProblemDefinition original, Cloner cloner) : base(original, cloner) {
+    }
+
     public dynamic vars { get; set; }
 
-    public abstract void Initialize();
+    public override IDeepCloneable Clone(Cloner cloner) =>
+      new CompiledProblemDefinition(this, cloner);
+
+    public virtual void Initialize() {
+    }
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/FileBasedLinearProblemDefinition.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/FileBasedLinearProblemDefinition.cs	(revision 16582)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/FileBasedLinearProblemDefinition.cs	(revision 16582)
@@ -0,0 +1,99 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+using System.IO;
+using Google.OrTools.LinearSolver;
+using HeuristicLab.Common;
+using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
+
+  [Item("Linear Problem Definition File (MPS, OR-Tools Protocol Buffers Files)", "File that defines the model for linear/mixed integer programming problem.")]
+  [StorableClass]
+  public sealed class FileBasedLinearProblemDefinition : ParameterizedNamedItem, ILinearProblemDefinition {
+
+    [Storable]
+    private readonly IFixedValueParameter<FileValue> fileNameParam;
+
+    [Storable]
+    private byte[] fileContent;
+
+    public FileBasedLinearProblemDefinition() {
+      Parameters.Add(fileNameParam = new FixedValueParameter<FileValue>(nameof(FileName), new FileValue()));
+      fileNameParam.Value.FileDialogFilter =
+        "All Supported Files (*.mps;*.bin;*.prototxt)|*.mps;*.bin;*.prototxt|" +
+        "Mathematical Programming System Files (*.mps)|*.mps|" +
+        "Google OR-Tools Protocol Buffers Files (*.bin;*.prototxt)|*.bin;*.prototxt|" +
+        "All Files (*.*)|*.*";
+      fileNameParam.Value.PathChanged += (o, e) => {
+        if (File.Exists(FileName)) {
+          fileContent = File.ReadAllBytes(FileName);
+        }
+      };
+    }
+
+    private FileBasedLinearProblemDefinition(FileBasedLinearProblemDefinition original, Cloner cloner)
+      : base(original, cloner) {
+      fileNameParam = cloner.Clone(original.fileNameParam);
+    }
+
+    [StorableConstructor]
+    private FileBasedLinearProblemDefinition(bool deserializing) : base(deserializing) { }
+
+    public new static Image StaticItemImage => VSImageLibrary.File;
+
+    public string FileName {
+      get => fileNameParam.Value.Value;
+      set => fileNameParam.Value.Value = value;
+    }
+
+    public IFixedValueParameter<FileValue> FileNameParam => fileNameParam;
+
+    public void Analyze(Solver solver, ResultCollection results) {
+    }
+
+    public void BuildModel(Solver solver) {
+      var fileInfo = new FileInfo(FileName);
+      var tempFileName = Path.GetTempFileName();
+
+      try {
+        File.WriteAllBytes(tempFileName, fileContent);
+
+        var status = (SolverResponseStatus)(fileInfo.Extension == ".mps"
+          ? solver.ImportModelFromMpsFormat(tempFileName)
+          : solver.ImportModelFromProtoFormat(tempFileName));
+
+        if (status == SolverResponseStatus.Abnormal)
+          throw new FileFormatException($"'{FileName}' is not a valid MPS or Google OR-Tools Protocol Buffers file.");
+      } finally {
+        File.Delete(tempFileName);
+      }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) => new FileBasedLinearProblemDefinition(this, cloner);
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/ILinearProblemDefinition.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/ILinearProblemDefinition.cs	(revision 16582)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/ILinearProblemDefinition.cs	(revision 16582)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using Google.OrTools.LinearSolver;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
+
+  public interface ILinearProblemDefinition : IItem {
+
+    void Analyze(Solver solver, ResultCollection results);
+
+    void BuildModel(Solver solver);
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/LinearProblem.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/LinearProblem.cs	(revision 16582)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/LinearProblem.cs	(revision 16582)
@@ -0,0 +1,147 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Reflection;
+using Google.OrTools.LinearSolver;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
+
+  [Item("Mixed-Integer Linear Programming Problem (LP, MIP)", "Represents a linear/mixed integer problem.")]
+  [StorableClass]
+  public sealed class LinearProblem : Problem, IStorableContent {
+
+    [Storable]
+    private readonly IValueParameter<ILinearProblemDefinition> problemDefinitionParam;
+
+    public LinearProblem() {
+      Parameters.Remove(Parameters["Operators"]);
+      Parameters.Add(problemDefinitionParam = new ValueParameter<ILinearProblemDefinition>("Model",
+        new ProgrammableLinearProblemDefinition(), false));
+    }
+
+    private LinearProblem(LinearProblem original, Cloner cloner)
+      : base(original, cloner) {
+      problemDefinitionParam = cloner.Clone(original.problemDefinitionParam);
+    }
+
+    [StorableConstructor]
+    private LinearProblem(bool deserializing) : base(deserializing) {
+    }
+
+    public event EventHandler ProblemDefinitionChanged;
+
+    public string Filename { get; set; }
+
+    public ILinearProblemDefinition ProblemDefinition {
+      get => problemDefinitionParam.Value;
+      set {
+        if (problemDefinitionParam.Value == value)
+          return;
+        problemDefinitionParam.Value = value;
+        ProblemDefinitionChanged?.Invoke(this, EventArgs.Empty);
+      }
+    }
+
+    public IValueParameter<ILinearProblemDefinition> ProblemDefinitionParameter => problemDefinitionParam;
+
+    public override IDeepCloneable Clone(Cloner cloner) => new LinearProblem(this, cloner);
+
+    public override void CollectParameterValues(IDictionary<string, IItem> values) {
+      base.CollectParameterValues(values);
+
+      if (ProblemDefinition == null) return;
+
+      values.Add("Model Type", new StringValue(
+        (ProblemDefinition.GetType().GetCustomAttributes().Single(a => a is ItemAttribute) as ItemAttribute).Name));
+
+      if (ProblemDefinition is ProgrammableLinearProblemDefinition model) {
+        values.Add("Model Name", new StringValue(model.Name));
+      }
+    }
+
+    public void ExportModel(string fileName) {
+      if (string.IsNullOrWhiteSpace(fileName))
+        throw new ArgumentNullException(nameof(fileName));
+      if (ProblemDefinition == null)
+        throw new ArgumentNullException(nameof(ProblemDefinition));
+
+      var fileInfo = new FileInfo(fileName);
+
+      if (!fileInfo.Directory?.Exists ?? false) {
+        Directory.CreateDirectory(fileInfo.Directory.FullName);
+      }
+
+      var solver = new Solver(ProblemDefinition.ItemName, Solver.OptimizationProblemType.CbcMixedIntegerProgramming);
+
+      ProblemDefinition.BuildModel(solver);
+
+      var exportSuccessful = false;
+      switch (fileInfo.Extension) {
+        case ".lp":
+          var lpFormat = solver.ExportModelAsLpFormat(false);
+          if (!string.IsNullOrEmpty(lpFormat)) {
+            File.WriteAllText(fileName, lpFormat);
+            exportSuccessful = true;
+          }
+          break;
+
+        case ".mps":
+          var mpsFormat = solver.ExportModelAsMpsFormat(false, false);
+          if (!string.IsNullOrEmpty(mpsFormat)) {
+            File.WriteAllText(fileName, mpsFormat);
+            exportSuccessful = true;
+          }
+          break;
+
+        case ".prototxt":
+          exportSuccessful = solver.ExportModelAsProtoFormat(fileName,
+            (Google.OrTools.LinearSolver.ProtoWriteFormat)ProtoWriteFormat.ProtoText);
+          break;
+
+        case ".bin": // remove file extension as it is added by OR-Tools
+          fileName = Path.ChangeExtension(fileName, null);
+          exportSuccessful = solver.ExportModelAsProtoFormat(fileName,
+            (Google.OrTools.LinearSolver.ProtoWriteFormat)ProtoWriteFormat.ProtoBinary);
+          break;
+
+        default:
+          throw new NotSupportedException($"File format {fileInfo.Extension} to export model is not supported.");
+      }
+
+      if (!exportSuccessful)
+        throw new InvalidDataException("Model could not be exported.");
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+    }
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/ProgrammableLinearProblemDefinition.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/ProgrammableLinearProblemDefinition.cs	(revision 16582)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/LinearProgramming/Problems/ProgrammableLinearProblemDefinition.cs	(revision 16582)
@@ -0,0 +1,151 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Reflection;
+using Google.OrTools.LinearSolver;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.ExactOptimization.LinearProgramming.Templates;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.Programmable;
+using HeuristicLab.Scripting;
+
+namespace HeuristicLab.ExactOptimization.LinearProgramming {
+
+  [Item("Programmable Linear Problem Definition (LP, MIP)",
+    "Script that defines the model for a linear/mixed integer programming problem.")]
+  [StorableClass]
+  public sealed class ProgrammableLinearProblemDefinition : Script, ILinearProblemDefinition,
+    IStorableContent {
+    private readonly object compileLock = new object();
+
+    [Storable]
+    private readonly VariableStore variableStore;
+
+    [Storable]
+    private bool codeChanged;
+
+    private volatile ILinearProblemDefinition compiledProblemDefinition;
+
+    public ProgrammableLinearProblemDefinition()
+      : base(ScriptTemplates.CompiledLinearProblemDefinition) {
+      Name = "Programmable Linear Problem Definition";
+      variableStore = new VariableStore();
+    }
+
+    [StorableConstructor]
+    private ProgrammableLinearProblemDefinition(bool deserializing) : base(deserializing) {
+    }
+
+    private ProgrammableLinearProblemDefinition(ProgrammableLinearProblemDefinition original,
+      Cloner cloner) : base(original, cloner) {
+      variableStore = cloner.Clone(original.variableStore);
+      codeChanged = original.codeChanged;
+    }
+
+    public event EventHandler ProblemDefinitionChanged;
+
+    public string Filename { get; set; }
+    public dynamic Instance => compiledProblemDefinition;
+    public VariableStore VariableStore => variableStore;
+
+    private ILinearProblemDefinition CompiledProblemDefinition {
+      get {
+        // double checked locking pattern
+        if (compiledProblemDefinition == null) {
+          lock (compileLock) {
+            if (compiledProblemDefinition == null) {
+              if (codeChanged)
+                throw new ProblemDefinitionScriptException("The code has been changed, but was not recompiled.");
+              Compile(false);
+            }
+          }
+        }
+
+        return compiledProblemDefinition;
+      }
+    }
+
+    public void Analyze(Solver solver, ResultCollection results) => CompiledProblemDefinition.Analyze(solver, results);
+
+    public void BuildModel(Solver solver) => CompiledProblemDefinition.BuildModel(solver);
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ProgrammableLinearProblemDefinition(this, cloner);
+    }
+
+    public override Assembly Compile() => Compile(true);
+
+    protected override void OnCodeChanged() {
+      base.OnCodeChanged();
+      compiledProblemDefinition = null;
+      codeChanged = true;
+    }
+
+    private Assembly Compile(bool fireChanged) {
+      var assembly = base.Compile();
+      var types = assembly.GetTypes();
+      if (!types.Any(x => typeof(CompiledProblemDefinition).IsAssignableFrom(x)))
+        throw new ProblemDefinitionScriptException("The compiled code doesn't contain a problem definition." + Environment.NewLine +
+                                                   $"The problem definition must be a subclass of {nameof(CompiledProblemDefinition)} and implement {nameof(ILinearProblemDefinition)}.");
+      if (types.Count(x => typeof(CompiledProblemDefinition).IsAssignableFrom(x)) > 1)
+        throw new ProblemDefinitionScriptException("The compiled code contains multiple problem definitions." + Environment.NewLine +
+                                                   $"Only one subclass of {nameof(CompiledProblemDefinition)} is allowed.");
+
+      CompiledProblemDefinition inst;
+      try {
+        inst = (CompiledProblemDefinition)Activator.CreateInstance(types.Single(x =>
+         typeof(CompiledProblemDefinition).IsAssignableFrom(x)));
+      } catch (Exception e) {
+        compiledProblemDefinition = null;
+        throw new ProblemDefinitionScriptException(
+          "Instantiating the problem definition failed." + Environment.NewLine + "Check your default constructor.", e);
+      }
+
+      try {
+        inst.vars = new Variables(VariableStore);
+        inst.Initialize();
+      } catch (Exception e) {
+        compiledProblemDefinition = null;
+        throw new ProblemDefinitionScriptException(
+          "Initializing the problem definition failed." + Environment.NewLine + "Check your Initialize() method.", e);
+      }
+
+      try {
+        compiledProblemDefinition = (ILinearProblemDefinition)inst;
+        if (fireChanged) OnProblemDefinitionChanged();
+      } catch (Exception e) {
+        compiledProblemDefinition = null;
+        throw new ProblemDefinitionScriptException(
+          "Using the problem definition in the problem failed." + Environment.NewLine +
+          "Examine this error message carefully.", e);
+      }
+
+      codeChanged = false;
+      return assembly;
+    }
+
+    private void OnProblemDefinitionChanged() => ProblemDefinitionChanged?.Invoke(this, EventArgs.Empty);
+  }
+}
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Plugin.cs.frame
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Plugin.cs.frame	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Plugin.cs.frame	(revision 16582)
@@ -22,9 +22,9 @@
 using HeuristicLab.PluginInfrastructure;
 
-namespace HeuristicLab.MathematicalOptimization {
+namespace HeuristicLab.ExactOptimization {
 
-  [Plugin("HeuristicLab.MathematicalOptimization", "Provides support for mathematical optimization based on Google OR-Tools. " +
+  [Plugin("HeuristicLab.ExactOptimization", "Provides support for exact optimization based on Google OR-Tools. " +
     "Requires the Microsoft Visual C++ 2017 Redistributable (x64) - 14.16.27012: https://aka.ms/vs/15/release/vc_redist.x64.exe", "3.3.15.$WCREV$")]
-  [PluginFile("HeuristicLab.MathematicalOptimization-3.3.dll", PluginFileType.Assembly)]
+  [PluginFile("HeuristicLab.ExactOptimization-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
@@ -39,5 +39,5 @@
   [PluginDependency("HeuristicLab.Problems.Programmable", "3.3")]
   [PluginDependency("HeuristicLab.Scripting", "3.3")]
-  public class HeuristicLabMathematicalOptimizationPlugin : PluginBase {
+  public class HeuristicLabExactOptimizationPlugin : PluginBase {
   }
 }
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Properties/AssemblyInfo.cs.frame	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Properties/AssemblyInfo.cs.frame	(revision 16582)
@@ -27,10 +27,10 @@
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
-[assembly: AssemblyTitle("HeuristiclLab.MathematicalOptimization")]
-[assembly: AssemblyDescription("Provides support for mathematical optimization based on Google OR-Tools")]
+[assembly: AssemblyTitle("HeuristicLab.ExactOptimization")]
+[assembly: AssemblyDescription("Provides support for exact optimization based on Google OR-Tools")]
 [assembly: AssemblyConfiguration("")]
 [assembly: AssemblyCompany("HEAL")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2018 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2019 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
Index: /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Properties/Settings.Designer.cs
===================================================================
--- /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Properties/Settings.Designer.cs	(revision 16581)
+++ /branches/2931_OR-Tools_LP_MIP/HeuristicLab.MathematicalOptimization/3.3/Properties/Settings.Designer.cs	(revision 16582)
@@ -9,5 +9,5 @@
 //------------------------------------------------------------------------------
 
-namespace HeuristicLab.MathematicalOptimization.Properties {
+namespace HeuristicLab.ExactOptimization.Properties {
     
     
